--- old/usr/src/lib/libc/port/locale/nextwctype.c	Tue May 20 07:58:49 2014
+++ new/usr/src/lib/libc/port/locale/nextwctype.c	Tue May 20 07:58:49 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright (c) 2004 Tim J. Robbins.
  * All rights reserved.
  *
@@ -28,20 +29,32 @@
 #include "runetype.h"
 #include <wchar.h>
 #include <wctype.h>
+#include "localeimpl.h"
 
-wint_t
-__nextwctype(wint_t wc, wctype_t wct)
+/*
+ * nextwctype, while exposed on *BSD/MacOS X, is considered "consolidation
+ * private" for illumos.  Hence, we keep the _l version static for now.
+ * If we decide to make this public, just remove the static keyword and
+ * put it in the headers and mapfile.  (Should fix up the underscore prefix
+ * to __nextwctype() as well.)
+ */
+static wint_t
+nextwctype_l(wint_t wc, wctype_t wct, locale_t loc)
 {
 	size_t lim;
-	_RuneRange *rr = &_CurrentRuneLocale->__runetype_ext;
-	_RuneEntry *base, *re;
+	const _RuneLocale *rl;
+	const _RuneRange *rr;
+	const _RuneEntry *base, *re;
 	int noinc;
 
+	rl = loc->runelocale;
+	rr = &rl->__runetype_ext;
+
 	noinc = 0;
 	if (wc < _CACHED_RUNES) {
 		wc++;
 		while (wc < _CACHED_RUNES) {
-			if (_CurrentRuneLocale->__runetype[wc] & wct)
+			if (rl->__runetype[wc] & wct)
 				return (wc);
 			wc++;
 		}
@@ -85,4 +98,13 @@
 			return (wc);
 	}
 	return (-1);
+}
+
+/*
+ * External, but consolidation private routine.
+ */
+wint_t
+__nextwctype(wint_t wc, wctype_t wct)
+{
+	return (nextwctype_l(wc, wct, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/nl_langinfo.c	Tue May 20 07:58:49 2014
+++ new/usr/src/lib/libc/port/locale/nl_langinfo.c	Tue May 20 07:58:49 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2001, 2003 Alexey Zelkin <phantom@FreeBSD.org>
  * All rights reserved.
@@ -36,21 +37,21 @@
 #include "lmessages.h"
 #include "lmonetary.h"
 #include "timelocal.h"
+#include "localeimpl.h"
 
 #define	_REL(BASE) ((int)item-BASE)
 
-#define	MONETARY	(__get_current_monetary_locale())
-#define	TIME		(__get_current_time_locale())
-#define	MESSAGES	(__get_current_messages_locale())
-#define	NUMERIC		(__get_current_numeric_locale())
-
 #pragma weak _nl_langinfo = nl_langinfo
 
 char *
-nl_langinfo(nl_item item)
+nl_langinfo_l(nl_item item, locale_t loc)
 {
 	char *ret, *s, *cs;
-	static char *csym = NULL;
+	struct locdata *ldata;
+	const struct lc_monetary *lmon = loc->monetary;
+	const struct lc_numeric *lnum = loc->numeric;
+	const struct lc_messages *lmsgs = loc->messages;
+	const struct lc_time *ltime = loc->time;
 
 	switch (item) {
 	case CODESET:
@@ -57,12 +58,17 @@
 		ret = "";
 		/*
 		 * The codeset is the suffix of a locale, for most it will
-		 * will be UTF-8, as in "en.UTF-8".  Short form locales are
+		 * will be UTF-8, as in "en_US.UTF-8".  Short form locales are
 		 * not supported.  Note also that although FreeBSD uses
 		 * US-ASCII, Solaris historically has reported "646" for the
 		 * C locale.
+		 *
+		 * Note that this code will need to change if we ever support
+		 * POSIX defined locale variants (suffixes with an @ sign)
 		 */
-		if ((s = setlocale(LC_CTYPE, NULL)) != NULL) {
+		ldata = loc->locdata[LC_CTYPE];
+		s = ldata ? ldata->l_lname : NULL;
+		if (s != NULL) {
 			if ((cs = strchr(s, '.')) != NULL)
 				ret = cs + 1;
 			else if (strcmp(s, "C") == 0 || strcmp(s, "POSIX") == 0)
@@ -70,40 +76,40 @@
 		}
 		break;
 	case D_T_FMT:
-		ret = (char *)TIME->c_fmt;
+		ret = (char *)ltime->c_fmt;
 		break;
 	case D_FMT:
-		ret = (char *)TIME->x_fmt;
+		ret = (char *)ltime->x_fmt;
 		break;
 	case T_FMT:
-		ret = (char *)TIME->X_fmt;
+		ret = (char *)ltime->X_fmt;
 		break;
 	case T_FMT_AMPM:
-		ret = (char *)TIME->ampm_fmt;
+		ret = (char *)ltime->ampm_fmt;
 		break;
 	case AM_STR:
-		ret = (char *)TIME->am;
+		ret = (char *)ltime->am;
 		break;
 	case PM_STR:
-		ret = (char *)TIME->pm;
+		ret = (char *)ltime->pm;
 		break;
 	case DAY_1: case DAY_2: case DAY_3:
 	case DAY_4: case DAY_5: case DAY_6: case DAY_7:
-		ret = (char *)TIME->weekday[_REL(DAY_1)];
+		ret = (char *)ltime->weekday[_REL(DAY_1)];
 		break;
 	case ABDAY_1: case ABDAY_2: case ABDAY_3:
 	case ABDAY_4: case ABDAY_5: case ABDAY_6: case ABDAY_7:
-		ret = (char *)TIME->wday[_REL(ABDAY_1)];
+		ret = (char *)ltime->wday[_REL(ABDAY_1)];
 		break;
 	case MON_1: case MON_2: case MON_3: case MON_4:
 	case MON_5: case MON_6: case MON_7: case MON_8:
 	case MON_9: case MON_10: case MON_11: case MON_12:
-		ret = (char *)TIME->month[_REL(MON_1)];
+		ret = (char *)ltime->month[_REL(MON_1)];
 		break;
 	case ABMON_1: case ABMON_2: case ABMON_3: case ABMON_4:
 	case ABMON_5: case ABMON_6: case ABMON_7: case ABMON_8:
 	case ABMON_9: case ABMON_10: case ABMON_11: case ABMON_12:
-		ret = (char *)TIME->mon[_REL(ABMON_1)];
+		ret = (char *)ltime->mon[_REL(ABMON_1)];
 		break;
 	case ERA:
 		/* XXX: need to be implemented  */
@@ -126,64 +132,37 @@
 		ret = "";
 		break;
 	case RADIXCHAR:
-		ret = (char *)NUMERIC->decimal_point;
+		ret = (char *)lnum->decimal_point;
 		break;
 	case THOUSEP:
-		ret = (char *)NUMERIC->thousands_sep;
+		ret = (char *)lnum->thousands_sep;
 		break;
 	case YESEXPR:
-		ret = (char *)MESSAGES->yesexpr;
+		ret = (char *)lmsgs->yesexpr;
 		break;
 	case NOEXPR:
-		ret = (char *)MESSAGES->noexpr;
+		ret = (char *)lmsgs->noexpr;
 		break;
 	/*
-	 * YESSTR and NOSTR items marked with LEGACY are available, but not
-	 * recomended by SUSv2 to be used in portable applications since
-	 * they're subject to remove in future specification editions.
+	 * YESSTR and NOSTR items were removed from Issue 7.  But
+	 * older applications might still need them.  Their use is
+	 * discouraged.
 	 */
 	case YESSTR:	/* LEGACY  */
-		ret = (char *)MESSAGES->yesstr;
+		ret = (char *)lmsgs->yesstr;
 		break;
 	case NOSTR:	/* LEGACY  */
-		ret = (char *)MESSAGES->nostr;
+		ret = (char *)lmsgs->nostr;
 		break;
 	/*
 	 * SUSv2 special formatted currency string
 	 */
 	case CRNCYSTR:
-		ret = "";
-		cs = (char *)MONETARY->currency_symbol;
-		if (*cs != '\0') {
-			char pos = localeconv()->p_cs_precedes;
-
-			if (pos == localeconv()->n_cs_precedes) {
-				char psn = '\0';
-
-				if (pos == CHAR_MAX) {
-					if (strcmp(cs,
-					    MONETARY->mon_decimal_point) == 0)
-						psn = '.';
-				} else
-					psn = pos ? '-' : '+';
-				if (psn != '\0') {
-					int clen = strlen(cs);
-					char *newc;
-
-					newc = realloc(csym, clen + 2);
-					if (newc != NULL) {
-						free(csym);
-						csym = newc;
-						*csym = psn;
-						(void) strcpy(csym + 1, cs);
-						ret = csym;
-					}
-				}
-			}
-		}
+		ret = lmon->crncystr;
 		break;
+
 	case _DATE_FMT:		/* Solaris specific extension */
-		ret = (char *)TIME->date_fmt;
+		ret = (char *)ltime->date_fmt;
 		break;
 	/*
 	 * Note that FreeBSD also had a private D_MD_ORDER, but that appears
@@ -193,4 +172,10 @@
 		ret = "";
 	}
 	return (ret);
+}
+
+char *
+nl_langinfo(nl_item item)
+{
+	return (nl_langinfo_l(item, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/none.c	Tue May 20 07:58:50 2014
+++ new/usr/src/lib/libc/port/locale/none.c	Tue May 20 07:58:50 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins. All rights reserved.
  * Copyright (c) 1993
@@ -41,40 +42,25 @@
 #include <string.h>
 #include <wchar.h>
 #include <note.h>
-#include "runetype.h"
 #include "mblocal.h"
+#include "lctype.h"
 
-static size_t	_none_mbrtowc(wchar_t *_RESTRICT_KYWD,
-    const char *_RESTRICT_KYWD, size_t, mbstate_t *_RESTRICT_KYWD);
-
-static int	_none_mbsinit(const mbstate_t *);
-static size_t	_none_mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst,
-    const char **_RESTRICT_KYWD src, size_t nms, size_t len,
-    mbstate_t *_RESTRICT_KYWD);
-static size_t	_none_wcrtomb(char *_RESTRICT_KYWD, wchar_t,
-    mbstate_t *_RESTRICT_KYWD);
-static size_t	_none_wcsnrtombs(char *_RESTRICT_KYWD,
-    const wchar_t **_RESTRICT_KYWD,
-    size_t, size_t, mbstate_t *_RESTRICT_KYWD);
-
 /* setup defaults */
 
-int
-_none_init(_RuneLocale *rl)
+void
+_none_init(struct lc_ctype *lct)
 {
-	charset_is_ascii = 1;
-
-	__mbrtowc = _none_mbrtowc;
-	__mbsinit = _none_mbsinit;
-	__mbsnrtowcs = _none_mbsnrtowcs;
-	__wcrtomb = _none_wcrtomb;
-	__wcsnrtombs = _none_wcsnrtombs;
-	_CurrentRuneLocale = rl;
-	return (0);
+	lct->lc_is_ascii = 1;
+	lct->lc_mbrtowc = __mbrtowc_ascii;
+	lct->lc_mbsinit = __mbsinit_ascii;
+	lct->lc_mbsnrtowcs = __mbsnrtowcs_ascii;
+	lct->lc_wcrtomb = __wcrtomb_ascii;
+	lct->lc_wcsnrtombs = __wcsnrtombs_ascii;
+	lct->lc_max_mblen = 1;
 }
 
-static int
-_none_mbsinit(const mbstate_t *unused)
+int
+__mbsinit_ascii(const mbstate_t *unused)
 {
 	_NOTE(ARGUNUSED(unused));
 
@@ -85,8 +71,8 @@
 	return (1);
 }
 
-static size_t
-_none_mbrtowc(wchar_t *_RESTRICT_KYWD pwc, const char *_RESTRICT_KYWD s,
+size_t
+__mbrtowc_ascii(wchar_t *_RESTRICT_KYWD pwc, const char *_RESTRICT_KYWD s,
     size_t n, mbstate_t *_RESTRICT_KYWD unused)
 {
 	_NOTE(ARGUNUSED(unused));
@@ -102,8 +88,8 @@
 	return (*s == '\0' ? 0 : 1);
 }
 
-static size_t
-_none_wcrtomb(char *_RESTRICT_KYWD s, wchar_t wc,
+size_t
+__wcrtomb_ascii(char *_RESTRICT_KYWD s, wchar_t wc,
     mbstate_t *_RESTRICT_KYWD unused)
 {
 	_NOTE(ARGUNUSED(unused));
@@ -119,8 +105,8 @@
 	return (1);
 }
 
-static size_t
-_none_mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst, const char **_RESTRICT_KYWD src,
+size_t
+__mbsnrtowcs_ascii(wchar_t *_RESTRICT_KYWD dst, const char **_RESTRICT_KYWD src,
     size_t nms, size_t len, mbstate_t *_RESTRICT_KYWD unused)
 {
 	const char *s;
@@ -146,8 +132,8 @@
 	return (nchr);
 }
 
-static size_t
-_none_wcsnrtombs(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
+size_t
+__wcsnrtombs_ascii(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
     size_t nwc, size_t len, mbstate_t *_RESTRICT_KYWD unused)
 {
 	const wchar_t *s;
@@ -181,19 +167,3 @@
 	*src = s;
 	return (nchr);
 }
-
-/* setup defaults */
-
-size_t (*__mbrtowc)(wchar_t *_RESTRICT_KYWD, const char *_RESTRICT_KYWD,
-    size_t, mbstate_t *_RESTRICT_KYWD) = _none_mbrtowc;
-
-int (*__mbsinit)(const mbstate_t *) = _none_mbsinit;
-
-size_t (*__mbsnrtowcs)(wchar_t *_RESTRICT_KYWD, const char **_RESTRICT_KYWD,
-    size_t, size_t, mbstate_t *_RESTRICT_KYWD) = _none_mbsnrtowcs;
-
-size_t (*__wcrtomb)(char *_RESTRICT_KYWD, wchar_t, mbstate_t *_RESTRICT_KYWD) =
-    _none_wcrtomb;
-
-size_t (*__wcsnrtombs)(char *_RESTRICT_KYWD, const wchar_t **_RESTRICT_KYWD,
-    size_t, size_t, mbstate_t *_RESTRICT_KYWD) = _none_wcsnrtombs;
--- old/usr/src/lib/libc/port/locale/regcomp.c	Tue May 20 07:58:50 2014
+++ new/usr/src/lib/libc/port/locale/regcomp.c	Tue May 20 07:58:50 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright 2012 Milan Jurik. All rights reserved.
  * Copyright (c) 1992, 1993, 1994 Henry Spencer.
@@ -725,6 +726,7 @@
 	char c;
 	wint_t start, finish;
 	wint_t i;
+	locale_t loc = uselocale(NULL);
 
 	/* classify what we've got */
 	switch ((MORE()) ? PEEK() : '\0') {
@@ -772,16 +774,18 @@
 		if (start == finish)
 			CHadd(p, cs, start);
 		else {
-			if (_collate_load_error) {
+			if (loc->collate->lc_is_posix) {
 				(void) REQUIRE((uch)start <= (uch)finish,
 				    REG_ERANGE);
 				CHaddrange(p, cs, start, finish);
 			} else {
 				(void) REQUIRE(_collate_range_cmp(start,
-				    finish) <= 0, REG_ERANGE);
+				    finish, loc) <= 0, REG_ERANGE);
 				for (i = 0; i <= UCHAR_MAX; i++) {
-					if (_collate_range_cmp(start, i) <= 0 &&
-					    _collate_range_cmp(i, finish) <= 0)
+					if (_collate_range_cmp(start, i, loc)
+					    <= 0 &&
+					    _collate_range_cmp(i, finish, loc)
+					    <= 0)
 						CHadd(p, cs, i);
 				}
 			}
@@ -1367,6 +1371,7 @@
 	char buf[MB_LEN_MAX];
 	size_t clen;
 	mbstate_t mbs;
+	locale_t loc = uselocale(NULL);
 
 	/* avoid making error situations worse */
 	if (p->error != 0)
@@ -1378,7 +1383,7 @@
 	 * UTF-8 (see RFC 3629).
 	 */
 	if (MB_CUR_MAX > 1 &&
-	    strcmp(_CurrentRuneLocale->__encoding, "UTF-8") != 0)
+	    strcmp(loc->runelocale->__encoding, "UTF-8") != 0)
 		return;
 
 	/* find the longest OCHAR sequence in strip */
--- old/usr/src/lib/libc/port/locale/rune.c	Tue May 20 07:58:50 2014
+++ new/usr/src/lib/libc/port/locale/rune.c	Tue May 20 07:58:50 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -39,14 +40,15 @@
 #include <stdlib.h>
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <sys/mman.h>
+#include <fcntl.h>
+#include <unistd.h>
 
 #include "runetype.h"
 #include "runefile.h"
 
-_RuneLocale *_Read_RuneMagi(FILE *);
-
 _RuneLocale *
-_Read_RuneMagi(FILE *fp)
+_Read_RuneMagi(const char *fname)
 {
 	char *fdata, *data;
 	void *lastp;
@@ -61,31 +63,30 @@
 	_FileRuneEntry *maplower_ext_ranges;
 	_FileRuneEntry *mapupper_ext_ranges;
 	int runetype_ext_len = 0;
+	int fd;
 
-	if (fstat(fileno(fp), &sb) < 0)
+	if ((fd = open(fname, O_RDONLY)) < 0) {
+		errno = EINVAL;
 		return (NULL);
+	}
 
-	if ((size_t)sb.st_size < sizeof (_FileRuneLocale)) {
+	if (fstat(fd, &sb) < 0) {
+		(void) close(fd);
 		errno = EINVAL;
 		return (NULL);
 	}
 
-	if ((fdata = malloc(sb.st_size)) == NULL)
+	if ((size_t)sb.st_size < sizeof (_FileRuneLocale)) {
+		(void) close(fd);
+		errno = EINVAL;
 		return (NULL);
-
-	errno = 0;
-	rewind(fp); /* Someone might have read the magic number once already */
-	if (errno) {
-		saverr = errno;
-		free(fdata);
-		errno = saverr;
-		return (NULL);
 	}
 
-	if (fread(fdata, sb.st_size, 1, fp) != 1) {
-		saverr = errno;
-		free(fdata);
-		errno = saverr;
+
+	fdata = mmap(NULL, sb.st_size, PROT_READ, MAP_PRIVATE, fd, 0);
+	(void) close(fd);
+	if (fdata == NULL) {
+		errno = EINVAL;
 		return (NULL);
 	}
 
@@ -95,33 +96,25 @@
 	variable = frl + 1;
 
 	if (memcmp(frl->magic, _FILE_RUNE_MAGIC_1, sizeof (frl->magic))) {
-		free(fdata);
-		errno = EINVAL;
-		return (NULL);
+		goto invalid;
 	}
 
 	runetype_ext_ranges = (_FileRuneEntry *)variable;
 	variable = runetype_ext_ranges + frl->runetype_ext_nranges;
 	if (variable > lastp) {
-		free(fdata);
-		errno = EINVAL;
-		return (NULL);
+		goto invalid;
 	}
 
 	maplower_ext_ranges = (_FileRuneEntry *)variable;
 	variable = maplower_ext_ranges + frl->maplower_ext_nranges;
 	if (variable > lastp) {
-		free(fdata);
-		errno = EINVAL;
-		return (NULL);
+		goto invalid;
 	}
 
 	mapupper_ext_ranges = (_FileRuneEntry *)variable;
 	variable = mapupper_ext_ranges + frl->mapupper_ext_nranges;
 	if (variable > lastp) {
-		free(fdata);
-		errno = EINVAL;
-		return (NULL);
+		goto invalid;
 	}
 
 	frr = runetype_ext_ranges;
@@ -134,17 +127,13 @@
 			variable = types + len;
 			runetype_ext_len += len;
 			if (variable > lastp) {
-				free(fdata);
-				errno = EINVAL;
-				return (NULL);
+				goto invalid;
 			}
 		}
 	}
 
 	if ((char *)variable + frl->variable_len > (char *)lastp) {
-		free(fdata);
-		errno = EINVAL;
-		return (NULL);
+		goto invalid;
 	}
 
 	/*
@@ -157,7 +146,7 @@
 	    frl->variable_len);
 	if (data == NULL) {
 		saverr = errno;
-		free(fdata);
+		(void) munmap(fdata, sb.st_size);
 		errno = saverr;
 		return (NULL);
 	}
@@ -229,7 +218,7 @@
 	}
 
 	(void) memcpy(rl->__variable, variable, rl->__variable_len);
-	free(fdata);
+	(void) munmap(fdata, sb.st_size);
 
 	/*
 	 * Go out and zero pointers that should be zero.
@@ -247,4 +236,9 @@
 		rl->__mapupper_ext.__ranges = NULL;
 
 	return (rl);
+
+invalid:
+	(void) munmap(fdata, sb.st_size);
+	errno = EINVAL;
+	return (NULL);
 }
--- old/usr/src/lib/libc/port/locale/runetype.c	Tue May 20 07:58:50 2014
+++ new/usr/src/lib/libc/port/locale/runetype.c	Tue May 20 07:58:50 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -37,11 +38,11 @@
 #include "runetype.h"
 
 unsigned int
-___runetype(__ct_rune_t c)
+__runetype(const _RuneLocale *rl, __ct_rune_t c)
 {
 	size_t lim;
-	_RuneRange *rr = &_CurrentRuneLocale->__runetype_ext;
-	_RuneEntry *base, *re;
+	const _RuneRange *rr = &rl->__runetype_ext;
+	const _RuneEntry *base, *re;
 
 	if (c < 0 || c == EOF)
 		return (0L);
--- old/usr/src/lib/libc/port/locale/runetype.h	Tue May 20 07:58:50 2014
+++ new/usr/src/lib/libc/port/locale/runetype.h	Tue May 20 07:58:50 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -110,7 +111,7 @@
 
 typedef struct {
 	char		__magic[8];	/* Magic saying what version we are */
-	char		__encoding[32];	/* ASCII name of this encoding */
+	char		__encoding[32];	/* ASCII name of encoding */
 
 	unsigned int	__runetype[_CACHED_RUNES];
 	__rune_t	__maplower[_CACHED_RUNES];
@@ -132,6 +133,7 @@
 #define	_RUNE_MAGIC_1	"RuneMagi"	/* Indicates version 0 of RuneLocale */
 
 extern _RuneLocale _DefaultRuneLocale;
-extern _RuneLocale *_CurrentRuneLocale;
 
+unsigned int __runetype(const _RuneLocale *, int);
+
 #endif	/* !_RUNETYPE_H_ */
--- old/usr/src/lib/libc/port/locale/setlocale.c	Tue May 20 07:58:50 2014
+++ new/usr/src/lib/libc/port/locale/setlocale.c	Tue May 20 07:58:50 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1996 - 2002 FreeBSD Project
  * Copyright (c) 1991, 1993
@@ -41,194 +42,72 @@
 #include <stdlib.h>
 #include <string.h>
 #include <unistd.h>
-#include <alloca.h>
 #include <stdio.h>
 #include "collate.h"
-#include "lmonetary.h"	/* for __monetary_load_locale() */
-#include "lnumeric.h"	/* for __numeric_load_locale() */
-#include "lmessages.h"	/* for __messages_load_locale() */
+#include "lnumeric.h"	/* for struct lc_numeric */
+#include "lctype.h"	/* for struct lc_ctype */
 #include "setlocale.h"
-#include "ldpart.h"
-#include "timelocal.h" /* for __time_load_locale() */
 #include "../i18n/_loc_path.h"
+#include "localeimpl.h"
+#include "../i18n/_locale.h"
 
 /*
- * Category names for getenv()  Note that this was modified
- * for Solaris.  See <iso/locale_iso.h>.
- */
-#define	NUM_CATS	7
-static char *categories[7] = {
-	"LC_CTYPE",
-	"LC_NUMERIC",
-	"LC_TIME",
-	"LC_COLLATE",
-	"LC_MONETARY",
-	"LC_MESSAGES",
-	"LC_ALL",
-};
-
-/*
- * Current locales for each category
- */
-static char current_categories[NUM_CATS][ENCODING_LEN + 1] = {
-	"C",
-	"C",
-	"C",
-	"C",
-	"C",
-	"C",
-	"C",
-};
-
-/*
  * Path to locale storage directory.  See ../i18n/_loc_path.h
  */
 char	*_PathLocale = _DFLT_LOC_PATH;
 
-/*
- * The locales we are going to try and load
- */
-static char new_categories[NUM_CATS][ENCODING_LEN + 1];
-static char saved_categories[NUM_CATS][ENCODING_LEN + 1];
-static char current_locale_string[NUM_CATS * (ENCODING_LEN + 1 + 1)];
+static char	*current_locale(locale_t, int);
+static void	install_legacy(locale_t, int);
 
-static char	*currentlocale(void);
-static char	*loadlocale(int);
-static const char *__get_locale_env(int);
-
 char *
-setlocale(int category, const char *locale)
+setlocale(int category, const char *locname)
 {
-	int i, j, saverr;
-	const char *env, *r;
+	locale_t oldloc;
+	locale_t newloc;
+	int mask;
 
-	if (category < 0 || category >= NUM_CATS) {
+	if (category < 0 || category > LC_ALL) {
 		errno = EINVAL;
 		return (NULL);
 	}
 
-	if (locale == NULL)
-		return (category != LC_ALL ?
-		    current_categories[category] : currentlocale());
+	if (locname == NULL)
+		return (current_locale(__global_locale, category));
 
-	/*
-	 * Default to the current locale for everything.
-	 */
-	for (i = 0; i < NUM_CATS; ++i)
-		(void) strcpy(new_categories[i], current_categories[i]);
+	if ((oldloc = duplocale(__global_locale)) == NULL)
+		return (NULL);
 
-	/*
-	 * Now go fill up new_categories from the locale argument
-	 */
-	if (!*locale) {
-		if (category == LC_ALL) {
-			for (i = 0; i < NUM_CATS; ++i) {
-				if (i == LC_ALL)
-					continue;
-				env = __get_locale_env(i);
-				if (strlen(env) > ENCODING_LEN) {
-					errno = EINVAL;
-					return (NULL);
-				}
-				(void) strcpy(new_categories[i], env);
-			}
-		} else {
-			env = __get_locale_env(category);
-			if (strlen(env) > ENCODING_LEN) {
-				errno = EINVAL;
-				return (NULL);
-			}
-			(void) strcpy(new_categories[category], env);
-		}
-	} else if (category != LC_ALL) {
-		if (strlen(locale) > ENCODING_LEN) {
-			errno = EINVAL;
-			return (NULL);
-		}
-		(void) strcpy(new_categories[category], locale);
-	} else {
-		if ((r = strchr(locale, '/')) == NULL) {
-			if (strlen(locale) > ENCODING_LEN) {
-				errno = EINVAL;
-				return (NULL);
-			}
-			for (i = 0; i < NUM_CATS; ++i)
-				(void) strcpy(new_categories[i], locale);
-		} else {
-			char	*buf;
-			char	*save;
+	mask = (category == LC_ALL ? LC_ALL_MASK : (1 << category));
 
-			buf = alloca(strlen(locale) + 1);
-			(void) strcpy(buf, locale);
-
-			save = NULL;
-			r = strtok_r(buf, "/", &save);
-			for (i = 0;  i < NUM_CATS; i++) {
-				if (i == LC_ALL)
-					continue;
-				if (r == NULL) {
-					/*
-					 * Composite Locale is inadequately
-					 * specified!   (Or with empty fields.)
-					 * The old code would fill fields
-					 * out from the last one, but I think
-					 * this is suboptimal.
-					 */
-					errno = EINVAL;
-					return (NULL);
-				}
-				(void) strlcpy(new_categories[i], r,
-				    ENCODING_LEN);
-				r = strtok_r(NULL, "/", &save);
-			}
-			if (r != NULL) {
-				/*
-				 * Too many components - we had left over
-				 * data in the LC_ALL.  It is malformed.
-				 */
-				errno = EINVAL;
-				return (NULL);
-			}
-		}
+	newloc = newlocale(mask, locname, oldloc);
+	if (newloc == NULL) {
+		freelocale(oldloc);
+		return (NULL);
 	}
 
-	if (category != LC_ALL)
-		return (loadlocale(category));
+	oldloc = __global_locale;
+	__global_locale = newloc;
 
-	for (i = 0; i < NUM_CATS; ++i) {
-		(void) strcpy(saved_categories[i], current_categories[i]);
-		if (i == LC_ALL)
-			continue;
-		if (loadlocale(i) == NULL) {
-			saverr = errno;
-			for (j = 0; j < i; j++) {
-				(void) strcpy(new_categories[j],
-				    saved_categories[j]);
-				if (i == LC_ALL)
-					continue;
-				if (loadlocale(j) == NULL) {
-					(void) strcpy(new_categories[j], "C");
-					(void) loadlocale(j);
-				}
-			}
-			errno = saverr;
-			return (NULL);
-		}
-	}
-	return (currentlocale());
+	install_legacy(newloc, mask);
+
+	freelocale(oldloc);
+	return (current_locale(newloc, category));
 }
 
 static char *
-currentlocale(void)
+current_locale(locale_t loc, int cat)
 {
-	int i;
 	int composite = 0;
+	static char buf[LC_ALL * (ENCODING_LEN + 1 + 1)];
 
+	if (cat != LC_ALL) {
+		return (loc->locdata[cat]->l_lname);
+	}
+
 	/* Look to see if any category is different */
-	for (i = 1; i < NUM_CATS; ++i) {
-		if (i == LC_ALL)
-			continue;
-		if (strcmp(current_categories[0], current_categories[i])) {
+	for (int i = 1; i < LC_ALL; ++i) {
+		if (strcmp(loc->locdata[0]->l_lname,
+		    loc->locdata[i]->l_lname) != 0) {
 			composite = 1;
 			break;
 		}
@@ -240,90 +119,63 @@
 		 * if the order is changed, then setlocale() will need
 		 * to be changed as well.
 		 */
-		(void) snprintf(current_locale_string,
-		    sizeof (current_locale_string),
+		(void) snprintf(buf, sizeof (buf),
 		    "%s/%s/%s/%s/%s/%s",
-		    current_categories[LC_CTYPE],
-		    current_categories[LC_NUMERIC],
-		    current_categories[LC_TIME],
-		    current_categories[LC_COLLATE],
-		    current_categories[LC_MONETARY],
-		    current_categories[LC_MESSAGES]);
-	} else {
-		(void) strlcpy(current_locale_string, current_categories[0],
-		    sizeof (current_locale_string));
+		    loc->locdata[LC_CTYPE]->l_lname,
+		    loc->locdata[LC_NUMERIC]->l_lname,
+		    loc->locdata[LC_TIME]->l_lname,
+		    loc->locdata[LC_COLLATE]->l_lname,
+		    loc->locdata[LC_MONETARY]->l_lname,
+		    loc->locdata[LC_MESSAGES]->l_lname);
+		return (buf);
 	}
-	return (current_locale_string);
+
+	return (loc->locdata[0]->l_lname);
 }
 
-static char *
-loadlocale(int category)
+static void
+install_legacy(locale_t loc, int mask)
 {
-	char *new = new_categories[category];
-	char *old = current_categories[category];
-	int (*func)(const char *);
-
-	if ((new[0] == '.' &&
-	    (new[1] == '\0' || (new[1] == '.' && new[2] == '\0'))) ||
-	    strchr(new, '/') != NULL) {
-		errno = EINVAL;
-		return (NULL);
+	/*
+	 * Update the legacy fixed variables that may be baked into
+	 * legacy programs.  This is really unfortunate, but we can't
+	 * solve for them otherwise.  Note that such legacy programs
+	 * are only going to see the global locale settings, and cannot
+	 * benefit from uselocale().
+	 */
+	if (mask & LC_NUMERIC_MASK) {
+		struct lc_numeric *lnum;
+		lnum = loc->locdata[LC_NUMERIC]->l_data[0];
+		_numeric[0] = *lnum->decimal_point;
+		_numeric[1] = *lnum->thousands_sep;
 	}
 
-	switch (category) {
-	case LC_CTYPE:
-		func = __wrap_setrunelocale;
-		break;
-	case LC_COLLATE:
-		func = _collate_load_tables;
-		break;
-	case LC_TIME:
-		func = __time_load_locale;
-		break;
-	case LC_NUMERIC:
-		func = __numeric_load_locale;
-		break;
-	case LC_MONETARY:
-		func = __monetary_load_locale;
-		break;
-	case LC_MESSAGES:
-		func = __messages_load_locale;
-		break;
-	default:
-		errno = EINVAL;
-		return (NULL);
-	}
+	if (mask & LC_CTYPE_MASK) {
+		struct lc_ctype *lct;
+		lct = loc->locdata[LC_CTYPE]->l_data[0];
+		for (int i = 0; i < _CACHED_RUNES; i++) {
+			/* ctype can only encode the lower 8 bits. */
+			__ctype[i+1] = lct->lc_ctype_mask[i] & 0xff;
+			__ctype_mask[i] = lct->lc_ctype_mask[i];
+		}
 
-	if (strcmp(new, old) == 0)
-		return (old);
+		/* The bottom half is the toupper/lower array */
+		for (int i = 0; i < _CACHED_RUNES; i++) {
+			int u, l;
+			__ctype[258 + i] = i;
+			u = lct->lc_trans_upper[i];
+			l = lct->lc_trans_lower[i];
+			if (u && u != i)
+				__ctype[258+i] = u;
+			if (l && l != i)
+				__ctype[258+i] = l;
 
-	if (func(new) != _LDP_ERROR) {
-		(void) strcpy(old, new);
-		return (old);
-	}
+			/* Don't forget these annoyances either! */
+			__trans_upper[i] = u;
+			__trans_lower[i] = l;
+		}
 
-	return (NULL);
-}
-
-static const char *
-__get_locale_env(int category)
-{
-	const char *env;
-
-	/* 1. check LC_ALL. */
-	env = getenv(categories[LC_ALL]);
-
-	/* 2. check LC_* */
-	if (env == NULL || !*env)
-		env = getenv(categories[category]);
-
-	/* 3. check LANG */
-	if (env == NULL || !*env)
-		env = getenv("LANG");
-
-	/* 4. if none is set, fall to "C" */
-	if (env == NULL || !*env)
-		env = "C";
-
-	return (env);
+		/* Maximum mblen, cswidth, weird legacy */
+		__ctype[520] = lct->lc_max_mblen;
+	}
 }
--- old/usr/src/lib/libc/port/locale/setlocale.h	Tue May 20 07:58:50 2014
+++ new/usr/src/lib/libc/port/locale/setlocale.h	Tue May 20 07:58:50 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright (C) 1997 by Andrey A. Chernov, Moscow, Russia.
  * All rights reserved.
  *
@@ -33,7 +34,4 @@
 
 extern char *_PathLocale;
 
-int	__detect_path_locale(void);
-int	__wrap_setrunelocale(const char *);
-
 #endif /* !_SETLOCALE_H_ */
